(document:surround "/std/frame")

(po-domain "alterator-office-server")

(define *has-server* (make-cell #f))

;;; Functions

(define (apply-to-backend)
  (woo-catch/message
   (thunk
     (and
       (woo-write "/office-server-net"
                  'external_ifaces (external-ifaces value))
       (or (not (cell-ref *has-server*)) (write-ldap))))))

(define (write-ldap)
  (let ((basedn (ldap_basedn text)))
    (cond
      ((string-null? basedn)
         (woo-throw (_ "You should define Base DN")))
      (else
         (woo-write "/office-server-ldap"
                    'ldap_basedn basedn))
        )))

;;; UI

(gridbox
 columns "25;10;40;25"

 (spacer)
 (label (_ "Base DN:") align "right")
 (document:id ldap_basedn (edit ""))
 (spacer)

 (spacer colspan 4)

 (spacer)
 (label text (_ "Select external interfaces:") colspan 2)
 (spacer)

 (spacer)
 (document:id external-ifaces
   (checklistbox enumref "/office-server-net" colspan 2))
 (spacer)

)

(and (global 'frame:next)
  (frame:on-next (thunk (or (apply-to-backend) 'cancel))))

;;; Logic

(document:root (when loaded
                 (woo-catch/message
                  (thunk
		    (let ((data (woo-read-first "/office-server-ldap")))
		      (if (woo-get-option data 'has_server)
			(begin
			  (cell-set! *has-server* #t)
			  (ldap_basedn text (woo-get-option data 'ldap_basedn)))
			(frame:skip)))))))

