(document:surround "/std/frame")
(document:surround "/std/functions")
(po-domain "alterator-office-server")

;;; Functions

(define (write-root)
  (woo-catch/message
    (thunk
	(woo-write "/office-server-root"
		   'commit #t
		   'auto (auto value)
		   'passwd_1 (passwd_1 value)
		   'passwd_2 (passwd_2 value)
		   'passwd_auto (passwd_auto value)))))

(define (read-root)
  (woo-catch/message
    (thunk (let ((data (woo-read-first "/office-server-root")))
            (passwd_auto value (woo-get-option data 'passwd_auto))))))

;;; UI

(gridbox columns "20;60;20"
	(spacer)
	(label text (_ "Setup password for system administrator:"))
	(spacer)

	(spacer)
	(gridbox
	  columns "100;0"
	  (document:id auto (checkbox text (_ "Generate automatically") name "auto"))
	  (spacer)
	  (document:id passwd_1 (edit name "passwd_1" echo "stars" visibility #f))
	  (label name "passwd_1" text (small (_ "(enter passphrase)")) visibility #f)
	  (document:id passwd_2 (edit name "passwd_2" echo "stars" visibility #f))
	  (label name "passwd_1" text (small (_ "(repeat passphrase)")) visibility #f)
	  (document:id passwd_auto (edit name "passwd_auto" visibility #f))
	  (button text (_ "Generate") name "passwd_auto" visibility #f (when clicked (read-root)))
	  (label colspan 2 name "passwd_auto" visibility #f))
	(spacer)

	(label colspan 3)

	(spacer)
	(if (global 'frame:next)
	    (label)
	    (button text (_ "Apply") align "left" (when clicked (write-root))))
	(spacer))

;;; Logic

(frame:on-next (thunk (or (write-root) 'cancel)))

(effect-show "passwd_1" "auto" #f)
(effect-show "passwd_2" "auto" #f)
(effect-show "passwd_auto" "auto" #t)

(document:root
  (when loaded
    (read-root)
    (init-effect)
    (passwd_1 focus #t)
    (and (global 'frame:next) (frame:back-activity #f))))
